#!/usr/bin/python
# -* coding: iso-8859-1 -*-
"""
**********************************************************************
File Name:            test_EXP485.py
Dev:                  Daniele De Santis
Email:                desantis@areasx.com
Web:                  http://www.areasx.com

Versione:             0.1
Data:                 19/05/14
Note Hardware:        
Note Software:        Python 2.7
                      Modulo serial http://pyserial.sourceforge.net/pyserial.html
**********************************************************************
"""
import serial
import time
import sys
########################################
#
# CLASSE EXP485-gpio
#
########################################
class EXP485_gpio:
  def __init__(self):
    self.Debug    = 0
    self.Baudrate = 19200
    self.RX_Cmd   = ""
  
  def CheckOS(self):
    if sys.platform in ('linux-i386', 'linux2'): 
      return 1
    elif sys.platform in ('win32', 'dos') or sys.platform.startswith('ms-dos'):
      return 2
    return 0

  def Lan(self):
    pass
    
  def InitSerial(self):
    try:
      self.Serid             = serial.Serial()
      if(self.CheckOS()==2): #Windows
        self.Serid.port      = int(self.Port) - 1
      else: #Linux
        self.Serid.port      = self.Port
      self.Serid.baudrate    = self.Baudrate
      self.Serid.setDTR      = False
      self.Serid.open() #apre la porta com
      self.Mode              = 1
      return 1 # Serid
    except serial.SerialException, e:
      if(self.Debug): print "ERRORE - Apertura porta COM %s fallita" % self.Port
    return 0
    
  def CRC(self, cmd):
    poly = 0xA001
    CRC  = 0xFFFF
    for character in cmd:
      CRC = (CRC ^ (ord(character)))
      for i in range(8):
        CRC, carrybit = (CRC>>1),(CRC&1)
        if carrybit == 1: CRC = (CRC ^ poly)
    return CRC
  
  def Printhex(self, cmd, mode=0):
    tmp=""
    for i in cmd:
      if(mode): tmp+="%02X"     % ord(i)
      else:     tmp+="0x%02X "  % ord(i)
    return tmp

  def SendCmd(self, Address, Function, Register, Registervalue, Registerqt=1, Bytecount=2, Tout=1.0):
    TX_Cmd  = chr(Address) + chr(Function) + chr((Register>>8) & 0xFF) + chr((Register & 0xFF))
    if(Registerqt>1): 
      TX_Cmd = TX_Cmd + chr((Registerqt>>8) & 0xFF) + chr((Registerqt & 0xFF))
      if(Bytecount):    TX_Cmd =TX_Cmd + chr(Bytecount)
    for i in range (1,Bytecount+1):
      TX_Cmd =TX_Cmd + chr((Registervalue>>((Bytecount-i) * 0x08) & 0xFF))
    crc= self.CRC(TX_Cmd)
    TX_Cmd = TX_Cmd + chr((crc & 0xFF)) + chr(((crc>>8) & 0xFF)) #Appendo il CRC
    self.RX_Cmd=""
    if(self.Mode==1):
      if(self.Serid.isOpen()):
        time.sleep(0.02)
        self.Serid.flushOutput()
        self.Serid.flushInput()
        time.sleep(0.02)
        
        self.Serid.write(TX_Cmd)
        if(self.Debug): print "TX -> %s" % self.Printhex(TX_Cmd)
        T0 = time.time()
        self.RX_Cmd=""
        while(1):
          RX_Size=self.Serid.inWaiting()
          if (RX_Size>0):
            self.RX_Cmd =self.RX_Cmd + self.Serid.read(RX_Size)
            T0 = time.time()
          if((T0+Tout)< time.time()):
            RX_Size = len(self.RX_Cmd)
            break
        if (RX_Size>=4):
          if(self.Debug): print "RX <- %s" % self.Printhex(self.RX_Cmd)
          rx_CRC=self.RX_Cmd[RX_Size-2:RX_Size]
          my_CRC=self.CRC(self.RX_Cmd[0:-2])
          if((ord(rx_CRC[0])==(my_CRC & 0xFF)) and (ord(rx_CRC[1])==((my_CRC>>8) & 0xFF))):
            return RX_Size
          return -1
    return 0

#####################################################################

#####################################################################

#####################################################################


EXP485 = EXP485_gpio()
EXP485.Port = "/dev/ttyUSB1"
EXP485.Debug = 0
EXP485_Address = 0x01
if(EXP485.InitSerial()):
  print "Porta %s Aperta" % EXP485.Port
  time.sleep(1)
  res = EXP485.SendCmd(EXP485_Address, 0x4, 0x0005, 0x0001)
  if(res>0):
    print "Firmware EXP485 V %d.%d" % (ord(EXP485.RX_Cmd[3]),ord(EXP485.RX_Cmd[4]))
  
  #####################################################################
  print "Test controllo singolo rele'"
  for i in range(0,8):
    if(EXP485.SendCmd(EXP485_Address, 0x5, i, 0xFF00)>0):
      print "Rele' %d attivo" % (i+1)
    time.sleep(1)
    if(EXP485.SendCmd(EXP485_Address, 0x5, i,0x0000)>0):
      print "Rele' %d disattivato" % (i+1)
  time.sleep(1)
  #####################################################################
  

  #Test controllo contemporaneo 8 rel
  if(EXP485.SendCmd(EXP485_Address, 0x0F, 0x0000, 0x03, 0x0008, 0x01)>0):
    print "Tutti i Rele' Attivi"
  
  time.sleep(1)
  if(EXP485.SendCmd(EXP485_Address, 0x0F, 0x0000, 0x00, 0x0008, 0x01)>0):
    print "Tutti i Rele' disattivati"
  
  while(1):
    #####################################################################
    #Test acquisizione stato 8 rel
    print "Leggo  stato degli 8 rele'"
    res = EXP485.SendCmd(EXP485_Address, 0x01, 0x0000, 0x0001)
    if(res>0):
      gpo=ord(EXP485.RX_Cmd[3])
      for i in range(0, 8):
        print "Rele' %d = %d " % (i+1, ((gpo>>i) & 0x0001) )

    print "*" * 30
    
    #time.sleep(0.1)
    #####################################################################
    #Test lettura stato ingressi a contatto pulito
    print "Lettura stato ingressi"
    res=EXP485.SendCmd(EXP485_Address, 0x4, 0x0000, 0x0001)

    if(res>0):
      gpi = (ord(EXP485.RX_Cmd[4]) + (ord(EXP485.RX_Cmd[3])<<8))
      for i in range(0, 8):
        print "input %d = %d " % (i+1, ((gpi>>i) & 0x0001) )
      print "*" * 30
    
    #time.sleep(0.1)
    #####################################################################
    #Test acquisizione linee ADC (aprire i ponticelli sulla EXP485)
    print "Lettura Linee ADC"
    res=EXP485.SendCmd(EXP485_Address, 0x4, 0x0001, 0x0004)
    
    if(res>0): #04 (0x04) Read Input Registers 
      adc1 = (ord(EXP485.RX_Cmd[4]) + (ord(EXP485.RX_Cmd[3])<<8))
      adc2 = (ord(EXP485.RX_Cmd[6]) + (ord(EXP485.RX_Cmd[5])<<8))
      adc3 = (ord(EXP485.RX_Cmd[8]) + (ord(EXP485.RX_Cmd[7])<<8))
      adc4 = (ord(EXP485.RX_Cmd[10]) + (ord(EXP485.RX_Cmd[9])<<8))
      
      print "ADC1 %d" % adc1,
      print "%.1f V [%d]" % ((adc1 * 0.01), adc1)
      print "ADC2 %d" % adc2,
      print "%.1f V [%d]" % ((adc2 * 0.01), adc2)
      print "ADC3 %d" % adc3,
      print "%.1f V [%d]" % ((adc3 * 0.01), adc3)
      print "ADC4 %d" % adc4,
      print "%.1f V [%d]" % ((adc4 * 0.01), adc4)
      
    time.sleep(1)
else:
  print "ERRORE Apertura Porta COM"

sys.exit(1)
